Index: cprs/trunk/CPRS-Chart/Orders/fODMeds.pas
===================================================================
--- cprs/trunk/CPRS-Chart/Orders/fODMeds.pas	(revision 456)
+++ cprs/trunk/CPRS-Chart/Orders/fODMeds.pas	(revision 829)
@@ -3340,75 +3822,4 @@
 end;
 
-procedure TfrmODMeds.btnXSequenceClick(Sender: TObject);
-var
-  APoint: TPoint;
-begin
-  inherited;
-  inherited;
-  with TSpeedButton(Sender) do APoint := ClientToScreen(Point(0, Height));
-  popXSequence.Popup(APoint.X, APoint.Y);
-  pnlXSequence.Caption := btnXSequence.Caption;
-  {
-  with TSpeedButton(Sender) do APoint := ClientToScreen(Point(0, Height));
-  popXSequence.Popup(APoint.X, APoint.Y);
-  pnlXSequence.Caption := btnXSequence.Caption;
-  if (pnlXSequence.Caption = 'then') and
-      ((ValFor(COL_DURATION, ARow1) = '') or
-       (ValFor(COL_DURATION, ARow1) = '0')) then
-     begin
-       InfoBox('A duration is required when using "Then" as a conjunction','Duration Warning',MB_OK);
-       pnlXSequence.Caption := '';
-       btnXSequence.Caption := '';
-     end;
-     }
-end;
-
-procedure TfrmODMeds.popXSequenceClick(Sender: TObject);
-var
-  x: string;
-begin
-  inherited;
-  with TMenuItem(Sender) do if Tag > 0 then x := Caption else x := '';
- //AGP Changes 26.12 PSI-04-63
- //if ((x = 'then') and (FInptDlg)) and ((ValFor(COL_DURATION, ARow1) = '') or (ValFor(COL_DURATION, ARow1) = '0')) then
- //AGP change 26.32 Then/And conjunction requiring a duration to include outpatient orders
- if (x = 'then') and ((ValFor(COL_DURATION, ARow1) = '') or (ValFor(COL_DURATION, ARow1) = '0')) then
-     begin
-       InfoBox('A duration is required when using "Then" as a conjunction' + CRLF + CRLF+
-           'The patient will be instructed to take these doses consecutively, not concurrently.','Duration Warning',MB_OK);
-       x := '';
-     end;
-  btnXSequence.Caption := x;
-  pnlXSequence.Caption := btnXSequence.Caption;
-  grdDoses.Cells[COL_SEQUENCE, pnlXSequence.Tag] := Uppercase(x);
-  ControlChange(Sender);
-end;
-
-procedure TfrmODMeds.pnlXSequenceExit(Sender: TObject);
-begin
-  inherited;
-  grdDoses.Cells[COL_SEQUENCE, pnlXSequence.Tag] := Uppercase(btnXSequence.Caption);
-  if ActiveControl = grdDoses then
-  begin
-    //This next condition seldom occurs, since entering the dosage on the last
-    // row adds another row
-    if grdDoses.Row = grdDoses.RowCount - 1 then
-      grdDoses.RowCount := grdDoses.RowCount + 1;
-  end;
-  pnlXSequence.Tag := -1;
-  pnlXSequence.Hide;
-  RestoreDefaultButton;
-  RestoreCancelButton;
-  if (pnlMessage.Visible) and (memMessage.TabStop) then
-  begin
-    pnlMessage.Parent := grdDoses.Parent;
-    pnlMessage.TabOrder := grdDoses.TabOrder;
-    ActiveControl := memMessage;
-  end
-  else if grdDoses.Showing then
-    ActiveControl := grdDoses
-  else
-    ActiveControl := cboDosage;
-end;
 
 procedure TfrmODMeds.btnXInsertClick(Sender: TObject);
@@ -3463,4 +3874,110 @@
     Schedule  <TAB> (nothing)
     Duration  <TAB> Duration^Units }
+
+  // the following functions were created to get rid of a compile warning saying the
+  // return value may be undefined - too much branching logic in the case statements
+  // for the compiler to handle
+  
+  function GetSingleDoseSchedule: string;
+  begin
+    Result := UpperCase(Trim(cboSchedule.Text));
+    if chkPRN.Checked then Result := Result + ' PRN';
+    if UpperCase(Copy(Result, Length(Result) - 6, Length(Result))) = 'PRN PRN'
+      then Result := Copy(Result, 1, Length(Result) - 4);
+  end;
+
+  function GetSingleDoseScheduleEX: string;
+  begin
+    Result := '';
+    with cboSchedule do
+    begin
+      if ItemIndex > -1 then Result := Piece(Items[ItemIndex], U, 2);
+(*     if (Length(Result)=0) and (ItemIndex > -1) then
+        begin
+          Result := Piece(Items[ItemIndex], U, 1);
+          if Piece(Items[ItemIndex], U, 3) = 'P' then
+          begin
+            if RightStr(Result,3) = 'PRN' then
+              begin
+                Result := Copy(Result,1,Length(Result)-3); //Remove the Trailing PRN
+                if (RightStr(Result,1) = ' ') or (RightStr(Result,1) = '-') then
+                Result := Copy(Result,1,Length(Result)-1);
+              end;
+           Result := Result + ' AS NEEDED';
+          end;
+        end;
+    end; *)
+      if RightStr(Result,3) = 'PRN' then
+      begin
+        Result := Copy(Result,1,Length(Result)-3); //Remove the Trailing PRN
+        if (RightStr(Result,1) = ' ') or (RightStr(Result,1) = '-') then
+          Result := Copy(Result,1,Length(Result)-1);
+        Result := Result + ' AS NEEDED'
+      end;
+      if (Length(Result) > 0) and chkPRN.Checked then
+        Result := Result + ' AS NEEDED';
+      if UpperCase(Copy(Result, Length(Result) - 18, Length(Result))) = 'AS NEEDED AS NEEDED' then
+        Result := Copy(Result, 1, Length(Result) - 10);
+      if UpperCase(Copy(Result, Length(Result) - 12, Length(Result))) = 'PRN AS NEEDED' then
+      begin
+        Result := Copy(Result, 1, Length(Result) - 13);
+        if RightStr(Result,1)=' ' then
+          Result := Result + 'AS NEEDED'
+        else
+          Result := Result + ' AS NEEDED';
+      end;
+    end;
+  end;
+
+  function GetComplexDoseSchedule: string;
+  begin
+    with grdDoses do
+    begin
+      Result := Piece(Piece(Cells[COL_SCHEDULE, ARow], TAB, 2), U, 1);
+      if Result = '' then Result := Piece(Cells[COL_SCHEDULE, ARow], TAB, 1);
+      if valFor(VAL_CHKXPRN,ARow)='1' then Result := Result + ' PRN';
+      if UpperCase(Copy(Result, Length(Result) - 6, Length(Result))) = 'PRN PRN' then
+      Result := Copy(Result, 1, Length(Result) - 4);
+    end;
+  end;
+
+  function GetComplexDoseScheduleEX: string;
+  begin
+    with grdDoses do
+    begin
+      (*Result := Piece(Piece(Cells[COL_SCHEDULE, ARow], TAB, 2), U, 2);
+      if Result = '' then //Added for CQ: 7639
+      begin
+        Result := Piece(Cells[COL_SCHEDULE, ARow], TAB, 1);
+        if RightStr(Result,4) = ' PRN' then
+          Result := Copy(Result,1,Length(Result)-4); //Remove the Trailing PRN
+      end;
+      if (Piece(Cells[COL_SCHEDULE, ARow], TAB, 1) <>
+         Piece(Piece(Cells[COL_SCHEDULE, ARow], TAB, 2), U, 1)) and
+         (Pos('PRN', Piece(Cells[COL_SCHEDULE, ARow], TAB, 1)) > 0)
+         then Result := Result + ' AS NEEDED';
+    end;*)
+      Result := Piece(Piece(Cells[COL_SCHEDULE, ARow], TAB, 2),U,2);
+      if Result = '' then Result := Piece(Piece(Cells[COL_SCHEDULE, ARow], TAB, 2),U,1); //Added for CQ: 7639
+      if Result = '' then Result := Piece(Cells[COL_SCHEDULE, ARow], TAB, 1);
+      if RightStr(Result,3) = 'PRN' then
+      begin
+        Result := Copy(Result,1,Length(Result)-3); //Remove the Trailing PRN
+        if (RightStr(Result,1) = ' ') or (RightStr(Result,1) = '-') then
+        Result := Copy(Result,1,Length(Result)-1);
+        Result := Result + ' AS NEEDED';
+      end;
+      if valFor(VAL_CHKXPRN,ARow)='1' then Result := Result + ' AS NEEDED';
+      if UpperCase(Copy(Result, Length(Result) - 18, Length(Result))) = 'AS NEEDED AS NEEDED'
+      then Result := Copy(Result, 1, Length(Result) - 10);
+      if UpperCase(Copy(Result, Length(Result) - 12, Length(Result))) = 'PRN AS NEEDED' then
+      begin
+        Result := Copy(Result, 1, Length(Result) - 13);
+        if RightStr(Result,1)=' ' then Result := Result + 'AS NEEDED'
+        else Result := Result + ' AS NEEDED';
+      end;
+    end;
+  end;
+  
 begin
   Result := '';
@@ -3496,46 +4013,9 @@
     FLD_ROUTE_EX  : with cboRoute do
                      if ItemIndex > -1  then Result := Piece(Items[ItemIndex], U, 4);
-    FLD_SCHEDULE  : begin        //gary)
-                      Result := UpperCase(Trim(cboSchedule.Text));
-                      if chkPRN.Checked then Result := Result + ' PRN';
-                      if UpperCase(Copy(Result, Length(Result) - 6, Length(Result))) = 'PRN PRN'
-                        then Result := Copy(Result, 1, Length(Result) - 4);
+    FLD_SCHEDULE  : begin      
+                      Result := GetSingleDoseSchedule;
                     end;
     FLD_SCHED_EX  : begin
-                      with cboSchedule do
-                        begin
-                        if ItemIndex > -1 then Result := Piece(Items[ItemIndex], U, 2);
-                   (*     if (Length(Result)=0) and (ItemIndex > -1) then
-                            begin
-                              Result := Piece(Items[ItemIndex], U, 1);
-                              if Piece(Items[ItemIndex], U, 3) = 'P' then
-                              begin
-                                if RightStr(Result,3) = 'PRN' then
-                                  begin
-                                    Result := Copy(Result,1,Length(Result)-3); //Remove the Trailing PRN
-                                    if (RightStr(Result,1) = ' ') or (RightStr(Result,1) = '-') then
-                                    Result := Copy(Result,1,Length(Result)-1);
-                                  end;
-                               Result := Result + ' AS NEEDED';
-                              end;
-                            end;
-                        end; *)
-                      if RightStr(Result,3) = 'PRN' then
-                           begin
-                              Result := Copy(Result,1,Length(Result)-3); //Remove the Trailing PRN
-                              if (RightStr(Result,1) = ' ') or (RightStr(Result,1) = '-') then
-                              Result := Copy(Result,1,Length(Result)-1);
-                              Result := Result + ' AS NEEDED'
-                           end;
-                      if (Length(Result) > 0) and chkPRN.Checked then Result := Result + ' AS NEEDED';
-                      if UpperCase(Copy(Result, Length(Result) - 18, Length(Result))) = 'AS NEEDED AS NEEDED'
-                        then Result := Copy(Result, 1, Length(Result) - 10);
-                      if UpperCase(Copy(Result, Length(Result) - 12, Length(Result))) = 'PRN AS NEEDED' then
-                          begin
-                            Result := Copy(Result, 1, Length(Result) - 13);
-                            if RightStr(Result,1)=' ' then Result := Result + 'AS NEEDED'
-                            else Result := Result + ' AS NEEDED';
-                          end;
-                    end;
+                      Result := GetSingleDoseScheduleEX;
                     end;
     FLD_SCHED_TYP : with cboSchedule do
@@ -3578,42 +4058,8 @@
       FLD_ROUTE_EX  : Result := Piece(Piece(Cells[COL_ROUTE, ARow], TAB, 2), U, 4);
       FLD_SCHEDULE  : begin
-                         Result := Piece(Piece(Cells[COL_SCHEDULE, ARow], TAB, 2), U, 1);
-                         if Result = '' then Result := Piece(Cells[COL_SCHEDULE, ARow], TAB, 1);
-                         if valFor(VAL_CHKXPRN,ARow)='1' then Result := Result + ' PRN';
-                         if UpperCase(Copy(Result, Length(Result) - 6, Length(Result))) = 'PRN PRN' then
-                         Result := Copy(Result, 1, Length(Result) - 4);
+                        Result := GetComplexDoseSchedule;
                       end;
       FLD_SCHED_EX  : begin
-                        (*Result := Piece(Piece(Cells[COL_SCHEDULE, ARow], TAB, 2), U, 2);
-                        if Result = '' then //Added for CQ: 7639
-                        begin
-                          Result := Piece(Cells[COL_SCHEDULE, ARow], TAB, 1);
-                          if RightStr(Result,4) = ' PRN' then
-                            Result := Copy(Result,1,Length(Result)-4); //Remove the Trailing PRN
-                        end;
-                        if (Piece(Cells[COL_SCHEDULE, ARow], TAB, 1) <>
-                           Piece(Piece(Cells[COL_SCHEDULE, ARow], TAB, 2), U, 1)) and
-                           (Pos('PRN', Piece(Cells[COL_SCHEDULE, ARow], TAB, 1)) > 0)
-                           then Result := Result + ' AS NEEDED';
-                      end;*)
-                        Result := Piece(Piece(Cells[COL_SCHEDULE, ARow], TAB, 2),U,2);
-                        if Result = '' then Result := Piece(Piece(Cells[COL_SCHEDULE, ARow], TAB, 2),U,1); //Added for CQ: 7639
-                        if Result = '' then Result := Piece(Cells[COL_SCHEDULE, ARow], TAB, 1);
-                        if RightStr(Result,3) = 'PRN' then
-                           begin
-                              Result := Copy(Result,1,Length(Result)-3); //Remove the Trailing PRN
-                              if (RightStr(Result,1) = ' ') or (RightStr(Result,1) = '-') then
-                              Result := Copy(Result,1,Length(Result)-1);
-                              Result := Result + ' AS NEEDED';
-                           end;
-                        if valFor(VAL_CHKXPRN,ARow)='1' then Result := Result + ' AS NEEDED';
-                        if UpperCase(Copy(Result, Length(Result) - 18, Length(Result))) = 'AS NEEDED AS NEEDED'
-                        then Result := Copy(Result, 1, Length(Result) - 10);
-                        if UpperCase(Copy(Result, Length(Result) - 12, Length(Result))) = 'PRN AS NEEDED' then
-                          begin
-                            Result := Copy(Result, 1, Length(Result) - 13);
-                            if RightStr(Result,1)=' ' then Result := Result + 'AS NEEDED'
-                            else Result := Result + ' AS NEEDED';
-                          end;
+                        Result := GetComplexDoseScheduleEX;
                       end;
       FLD_SCHED_TYP : Result := Piece(Piece(Cells[COL_SCHEDULE, ARow], TAB, 2), U, 3);
@@ -3641,8 +4087,5 @@
     FLD_PRIOR_NM  : Result := cboPriority.Text;
     FLD_COMMENT   : Result := memComment.Text;
-    FLD_SC        : if chkSC.Visible then
-                    begin
-                      if chkSC.Checked then Result := '1' else Result := '0';
-                    end;
+
     FLD_NOW_ID    : if chkDoseNow.Visible and chkDoseNow.Checked then Result := '1'   else Result := '';
     FLD_NOW_NM    : if chkDoseNow.Visible and chkDoseNow.Checked then Result := 'NOW' else Result := '';
@@ -3682,9 +4125,14 @@
 var
   ADrug: string;
-begin
+  Checked: boolean;
+  tmpSupply: integer;
+begin
+  Checked := false;
   if ((StrToFloatDef(txtQuantity.Text, 0) = 0) and (StrToIntDef(txtSupply.Text, 0) = 0) and
      (txtQuantity.Tag = 0) and (txtSupply.Tag = 0) and (cboDosage.Text <> ''))
-     or ((cboDosage.ItemIndex < 0) and not FIsQuickOrder ) then
-  begin
+     or ((cboDosage.ItemIndex < 0) and (not FIsQuickOrder)) or
+     ((IsClozapineOrder = true) and (FISQuickOrder) and (FQOInitial))  then
+  begin
+    Checked := True;
     ADrug := Piece(CurDispDrug, U, 1);
     CurSupply := DefaultDays(ADrug, CurUnits, CurSchedule);
@@ -3694,5 +4142,5 @@
       if (txtSupply.Text = '') or (StrToInt(txtSupply.Text)<>CurSupply)  then
         txtSupply.Text := IntToStr(CurSupply);
-      if (FIsQuickOrder and FQOInitial) then
+      if (FIsQuickOrder) and (FQOInitial) and (IsClozapineOrder = false) then
       begin
         if StrToFloatDef(txtSupply.Text,0) > 0 then
@@ -3712,5 +4160,27 @@
       SkipQtyCheck := TRUE;
     end;
-  end;
+    if FQOInitial = true then FQOInitial := False;    
+  end;
+  if (IsClozapineOrder = true) and (CurDispDrug <> '') and (CurDispDrug <> U)and (Checked = false) then
+    begin
+      ADrug := Piece(CurDispDrug, U, 1);
+      tmpSupply := DefaultDays(ADrug, CurUnits, CurSchedule);
+      if (tmpSupply > 0) and (CurSupply > tmpSupply) then
+        begin
+          CurSupply := tmpSupply;
+          spnSupply.Position := CurSupply;
+          if (txtSupply.Text = '') or (StrToInt(txtSupply.Text)<>CurSupply)  then
+          txtSupply.Text := IntToStr(CurSupply);
+        end;
+      CurQuantity := DaysToQty(CurSupply, CurUnits, CurSchedule, CurDuration, ADrug);
+      if CurQuantity >= 0 then
+      begin
+       //spnQuantity.Position := CurQuantity;
+       if (txtQuantity.Text <> '') and (CurQuantity > 0) then
+        txtQuantity.Text := FloatToStr(CurQuantity);
+       if (txtQuantity.Text = '') or (StrToInt(txtQuantity.Text) <> CurQuantity) and (CurQuantity > 0)  then
+         txtQuantity.Text := FloatToStr(CurQuantity);
+      end;
+    end;
 end;
 
@@ -3808,27 +4278,23 @@
 end;
 
-procedure TfrmODMeds.UpdateSC(const CurDispDrug: string);
-var
-  Dispense: Integer;
-begin
-  Dispense := StrToIntDef(Piece(CurDispDrug, U, 1), 0);  // just use first dispense drug for now
-  if Patient.ServiceConnected and RequiresCopay(Dispense) then
-  begin
-    chkSC.Visible := True;
-    if chkSC.Tag = 0 then chkSC.Checked := Patient.SCPercent > 50;
-    if chkSC.Hint = '' then chkSC.Hint := RatedDisabilities;
-  end
-  else chkSC.Visible := False;
-  FUpdated := True;
+procedure TfrmODMeds.updateSig;
+begin
+  inherited;
+  if self.tabDose.TabIndex = TI_DOSE then self.cboDosage.OnExit(cboDosage);
+  if self.tabDose.TabIndex = TI_COMPLEX then self.cboxDosage.OnExit(cboxDosage);
 end;
 
 procedure TfrmODMeds.UpdateStartExpires(const CurSchedule: string);
 var
-  CompSch, ShowText, Duration, ASchedule: string;
+  CompSch, CompDose, LastSch, ShowText, Duration, ASchedule, TempSch, schType, Admin, tempAdmin: string;
   AdminTime:    TFMDateTime;
-  i, j, Interval, PrnPos: Integer;
-begin
+  j, r, Interval, PrnPos, SchID: Integer;
+  EndCheck, rowCheck, DoseNow: boolean;
+begin
+  if not FInptDlg then Exit;
   if Length(CurSchedule)=0 then Exit;
   ASchedule := Trim(CurSchedule);
+  DoseNow := True;
+  if self.EvtID > 0 then DoseNow := false;
   if (Pos('^',ASchedule)>0) then
   begin
@@ -3837,51 +4303,153 @@
       Delete(ASchedule, PrnPos-1, 4);
   end;
+  if (FAdminTimeText = '') and (self.EvtID > 0) then FAdminTimeText := 'To Be Determined';
+  AdminTime := 0;
   ASchedule := Trim(ASchedule);
+  //AGP Change for CQ 9906
+  EndCheck := False;
+  lastSch := '';
   if self.tabDose.TabIndex = TI_COMPLEX then
     begin
-      CompSch := valFor(VAL_SCHEDULE,1);
-      if CompSch = '' then
-        begin
-          ASchedule := '';
-          AdminTime := -1;
-        end;
-      if CompSch <> '' then
-        begin
-          for i := 0 to self.cboXSchedule.Items.Count-1 do
-            begin
-              if (Piece(self.cboXSchedule.Items.Strings[i],U,1) = CompSch) and (Piece(self.cboXSchedule.Items.Strings[i],U,3)='P') then
+    tempSch := ASchedule;
+    ASchedule := '';
+    for r := 1 to self.grdDoses.RowCount-1 do
+      begin
+        CompSch := valFor(VAL_SCHEDULE,r);
+        CompDose := valFor(VAL_DOSAGE,r);
+        RowCheck := valFor(VAL_CHKXPRN,r)='1';
+        if (RowCheck = True) then
+          begin
+            if EndCheck = false then AdminTime := -1;
+            if FAdminTimeText = '' then self.grdDoses.cells[COL_ADMINTIME, r] := ''
+            else Self.grdDoses.Cells[COL_ADMINTIME, r] := FAdminTimeText;
+          end
+        else
+          begin
+            if CompSch <> '' then
+               begin
+                 //cboXSchedule.Items.IndexOfName(CompSch);
+                 //cboXSchedule.SelectByID(CompSch);
+                 SchID := -1;
+                 for j := 0 to cboXSchedule.Items.Count - 1 do
+                    begin
+                      if Piece(cboXSchedule.Items.Strings[j], U, 1) = CompSch then
+                        begin
+                          schID := j;
+                          break;
+                        end;
+                    end;
+                 //if cboXSchedule.ItemIndex > -1 then
+                 if SchID > -1 then
+                   begin
+                     //SchID := cboXSchedule.ItemIndex;
+                     if (Piece(self.cboXSchedule.Items.Strings[SchID],U,1) = CompSch) then
+                       begin
+                         SchType := Piece(self.cboXSchedule.Items.Strings[SchID],U,3);
+                         if (SchType = 'P') or (SchType = 'O') or (SchType = 'OC') then
+                             self.grdDoses.Cells[COL_ADMINTIME, r] := ''
+                         else if FAdminTimeText <> '' then self.grdDoses.Cells[COL_ADMINTIME, r] := FAdminTimeText
+                         else
+                           begin
+                             self.grdDoses.Cells[COL_ADMINTIME, r] := Piece(self.cboXSchedule.Items.Strings[SchID],U,4);
+                             if self.grdDoses.Cells[COL_ADMINTIME, r] = '' then self.grdDoses.Cells[COL_ADMINTIME, r] := 'Not Defined';
+
+                           end;
+                         if CompDose <> '' then
+                           begin
+                             lastSch := CompSch;
+                             if (EndCheck = False) and ((SchType = 'P') or (SchType = 'O')) then AdminTime := -1
+                             //else Aschedule := ';' + CompSch;
+                           end;
+                       end;
+                     
+                   end;
+               end;
+          end;
+        if ((valFor(VAL_SEQUENCE,r) = 'AND') or (valFor(VAL_SEQUENCE,r) = '')) and (AdminTime > -1) and (EndCheck = false) then
+          begin
+            //if (CompSch = '') and (LastSch <> '') and (Aschedule <> '') then CompSch := LastSch;
+            if (ASchedule <> '') and (CompSch <> '') and (RowCheck = False) then ASchedule := ASchedule + ';' + CompSch;
+            if (ASchedule = '') and (CompSch <> '') and (RowCheck = False) then ASchedule := ';' + CompSch;
+          end
+        else if ValFor(VAL_SEQUENCE, r) = 'THEN' then
+          begin
+           // if (CompSch = '') and (LastSch <> '') and (Aschedule <> '') then CompSch := LastSch;
+            if (ASchedule <> '') and (CompSch <> '') and (RowCheck = False) then ASchedule := ASchedule + ';' + CompSch;
+            if (ASchedule = '') and (CompSch <> '') and (RowCheck = False) then ASchedule := ';' + CompSch;
+            EndCheck := True;
+          end
+      end;
+    end;
+  if self.tabDose.TabIndex = TI_DOSE then
+    begin
+     if LeftStr(ASchedule, 1) = ';' then tempSch := Piece(ASchedule, ';', 2)
+     else tempSch := ASchedule;
+     if self.chkPRN.Checked = True then
+       begin
+         AdminTime := -1;
+         lblAdminSchSetText('');
+         if (cboSchedule.ItemIndex > -1) and (Piece(self.cboSchedule.Items.Strings[cboSchedule.itemIndex], U, 3) = 'O') then
+           DoseNow := false;
+       end
+     else begin
+         //cboSchedule.SelectByID(tempSch);
+         SchID := -1;
+         for j := 0 to cboSchedule.Items.Count - 1 do
+           begin
+             if Piece(cboSchedule.Items.Strings[j], U, 1) = tempSch then
                 begin
-                  AdminTime := -1;
-                  Aschedule := '';
+                  schID := j;
+                  break;
                 end;
-            end;
-        end;
-        if valFor(VAL_CHKXPRN,1)='1' then
-          begin
-            AdminTime := -1;
-            Aschedule := '';
-          end;
-      if (ASchedule <> '') and (CompSch <> '') then ASchedule := ';' + CompSch;
-    end;
-  if Length(ASchedule)>0 then
-      LoadAdminInfo(ASchedule, txtMed.Tag, ShowText, AdminTime, Duration);
-  //else Exit;
-  if (AdminTime > 0) and (self.tabDose.TabIndex = TI_DOSE) then
-    begin
-     if self.cboSchedule.ItemIndex = -1 then
-       begin
-         for j := 0 to self.cboSchedule.items.Count -1 do
+           end;
+         if schID > -1 then
            begin
-             if (Piece(self.cboSchedule.Items.Strings[j],U,1) = Piece(Aschedule,';',2)) and (Piece(self.cboSchedule.Items.Strings[j],U,3)='P') then
+             SchType := Piece(self.cboSchedule.Items.Strings[schID], U, 3);
+             if (SchType = 'P') or (SchType = 'OC') or (SchType = 'O') then
                begin
-                 AdminTime := -1;
-                 break;
+                 lblAdminSchSetText('');
+                 if (SchType = 'P') or (SchType = 'OC') or (SchType = 'O') then AdminTime := -1;
+                 if SchType = 'O' then DoseNow := false;
+               end
+             else
+               begin
+                 if FAdminTimeText <> '' then tempAdmin := 'Admin. Time: ' + FAdminTimeText
+                 else
+                   begin
+                      if Piece(self.cboSchedule.Items.Strings[schID], U, 4) <> '' then
+                          tempAdmin := 'Admin. Time: ' + Piece(self.cboSchedule.Items.Strings[schID], U, 4)
+                      else tempAdmin := 'Admin. Time: Not Defined';
+                   end;
+                  lblAdminSchSetText(tempAdmin);
+             (*    if FAdminTimeText <> '' then self.lblAdminSch.text := 'Admin. Time: ' + FAdminTimeText
+                 else
+                   begin
+                      if Piece(self.cboSchedule.Items.Strings[schID], U, 4) <> '' then
+                          self.lblAdminSch.text := 'Admin. Time: ' + Piece(self.cboSchedule.Items.Strings[schID], U, 4)
+                      else self.lblAdminSch.text := 'Admin. Time: Not Defined';
+                   end;   *)
+
                end;
            end;
        end;
-     if (self.cboSchedule.ItemIndex > -1) and (Piece(self.cboSchedule.Items.Strings[self.cboSchedule.ItemIndex],U,3)='P') then
-       AdminTime := -1;
-     if self.chkPRN.Checked = true then AdminTime := -1
-    end;
+    end;
+  if (Length(ASchedule)>0) and (AdminTime > -1) then
+     begin
+      if LeftStr(Aschedule, 1) <> ';' then ASchedule := ';'+ASchedule;
+      Admin := '';
+      if (self.lblAdminSch.visible = True) and (self.lblAdminSch.text <> '') and (self.tabDose.TabIndex = TI_DOSE) then
+        begin
+          //AGP Change Admin Time Wrap 27.73
+          //Admin := Copy(self.lblAdminSch.text,  14, (Length(self.lblAdminSch.text)-1));
+          Admin := lblAdminSchGetText;
+          if (Admin <> '') and (not (Admin[1] in ['0'..'9'])) then Admin := '';
+        end
+      else if self.tabDose.TabIndex = TI_COMPLEX then
+        begin
+          Admin := Self.grdDoses.Cells[COL_ADMINTIME, 1];
+          if (Admin <> '') and (not (Admin[1] in ['0'..'9'])) then Admin := '';
+        end;           
+      LoadAdminInfo(ASchedule, txtMed.Tag, ShowText, AdminTime, Duration, Admin);
+     end;
   if AdminTime > 0 then
   begin
@@ -3906,4 +4474,9 @@
   end
   else lblAdminTime.Caption := '';
+  if (lblAdminTime.Caption <> '') and (lblAdminTime.Visible = True) and (JAWSON = true) then lblAdminTime.TabStop := true
+  else lblAdminTime.TabStop := false;
+  if (lblAdminSch.text <> '') and (lblAdminSch.Visible = True) and (JAWSON = true) then lblAdminSch.TabStop := true
+  else lblAdminSch.TabStop := false;
+  DisplayDoseNow(DoseNow);
 end;
 
@@ -3914,5 +4487,5 @@
   else
     spnRefills.Max := CalcMaxRefills(CurDispDrug, CurSupply, txtMed.Tag, Responses.EventType = 'D');
-  if StrToIntDef(txtRefills.Text, 0) > spnRefills.Max then
+  if (StrToIntDef(txtRefills.Text, 0) > spnRefills.Max) then
   begin
     txtRefills.Text := IntToStr(spnRefills.Max);
@@ -3940,5 +4513,5 @@
   CurSupply, i, pNum, j: Integer;
   CurQuantity: double;
-  LackQtyInfo, SaveChanging, DispFirstDose: Boolean;
+  LackQtyInfo, SaveChanging: Boolean;
 begin
   inherited;
@@ -3947,5 +4520,4 @@
   SaveChanging := Changing;
   Changing := TRUE;
-  DispFirstDose := FALSE;
   // don't allow Exit procedure so Changing gets reset appropriately
   CurUnits    := '';
@@ -3997,4 +4569,5 @@
   CurQuantity := StrToFloatDef(ValueOfResponse(FLD_QUANTITY), 0);
   CurSupply   := StrToIntDef(ValueOfResponse(FLD_SUPPLY)   ,0);
+  //CurRefill  := StrToIntDef(ValueOfResponse(FLD_REFILLS) , 0);
   if FInptDlg then
   begin
@@ -4006,6 +4579,7 @@
           lblAdminTime.Caption := '';
     end;
-    if CurSchedule <> FLastSchedule then UpdateStartExpires(CurSchedule);
-    if (ValueOf(FLD_SCHED_TYP) = 'O')
+   if (self.tabDose.TabIndex = TI_DOSE) and (CurSchedule <> FLastSchedule) then UpdateStartExpires(CurSchedule);
+   //AGP remove this code for CQ 11772
+  (*if (ValueOf(FLD_SCHED_TYP) = 'O')
       or (Responses.EventType in ['A','D','T','M','O'])
       or ((Length(cboSchedule.Text)>0) and (cboSchedule.ItemIndex < 0)) then
@@ -4016,17 +4590,6 @@
         chkDoseNow.Checked := False;
       end;
-      for i := 0 to cboSchedule.Items.Count-1 do
-        begin
-                  if Piece(cboSchedule.Items.Strings[i],U,1) = Uppercase(cboSchedule.Text) then
-            begin
-              DispFirstDose := True;
-              break;
-            end;
-        end;
-      if not DispFirstDose then
-        begin
           chkDoseNow.Visible := False;
           lblAdminTime.Visible := False;
-        end;
     end
     else
@@ -4034,5 +4597,5 @@
         chkDoseNow.Visible := TRUE;
         lblAdminTime.Visible := not chkDoseNow.Checked;
-      end;
+      end;  *)
     if Responses.EventType in ['A','D','T','M','O'] then lblAdminTime.Visible := False;
   end;
@@ -4040,5 +4603,5 @@
   begin
     CurSchedule := CurScheduleOut;
-    if (CurInstruct <> FLastInstruct) and (CurUnits <> U) //AGP Change 26.48 Do not update quantity and day supply if no matching dose on the server
+    if ((CurInstruct <> FLastInstruct) and (CurUnits <> U)) or ((IsClozapineOrder = true) and (CurDispDrug <> '') and (CurDispDrug <> U)) //AGP Change 26.48 Do not update quantity and day supply if no matching dose on the server
       then UpdateDefaultSupply(CurUnits, CurSchedule, CurDuration, CurDispDrug, CurSupply, CurQuantity,
                                LackQtyInfo);
@@ -4049,6 +4612,6 @@
     else
       UpdateSupplyQuantity(CurUnits, CurSchedule, CurDuration, CurDispDrug, CurSupply, CurQuantity);
-    if (CurDispDrug <> FLastDispDrug) then UpdateSC(CurDispDrug);
-    if (CurDispDrug <> FLastDispDrug) or (CurSupply <> FLastSupply) then
+   // if (CurDispDrug <> FLastDispDrug) then UpdateSC(CurDispDrug);
+    if ((CurDispDrug <> FLastDispDrug) or (CurSupply <> FLastSupply)) and ((CurDispDrug <> '') and (CurSupply > 0))  then
       UpdateRefills(CurDispDrug, CurSupply);
   end;
@@ -4098,4 +4661,12 @@
     then DisplayGroup := DisplayGroupByName('UD RX')
   else DisplayGroup := DisplayGroupByName('O RX');
+ (* if (Not FInptDlg) then
+    begin
+      if (ValidateDaySupplyandQuantity(strtoInt(txtSupply.Text), strtoInt(txtQuantity.text)) = false) then Exit
+      else ClearMaxData;
+    end;   *)
+  //if (Not FInptDlg) and (ValidateMaxQuantity(strtoInt(txtQuantity.Text)) = false) then Exit;
+  
+
   //timCheckChangesTimer(Self);
   DropLastSequence;
@@ -4135,5 +4706,6 @@
     if length(theSch)>0 then
     begin
-      if ( (ValueOf(FLD_SCHED_TYP) <> 'O') and (InfoBox(T1+medNm+T+T2+theSch+T+T3+'NOW"'+T4, 'Warning', MB_OKCANCEL or MB_ICONWARNING) = IDCANCEL) )then
+      //if ( (ValueOf(FLD_SCHED_TYP) <> 'O') and (InfoBox(T1+medNm+T+T2+theSch+T+T3+'NOW"'+T4, 'Warning', MB_OKCANCEL or MB_ICONWARNING) = IDCANCEL) )then
+      if InfoBox(T1+medNm+T+T2+theSch+T+T3+'NOW"'+T4, 'Warning', MB_OKCANCEL or MB_ICONWARNING) = IDCANCEL then
       begin
         chkDoseNow.Checked := False;
@@ -4152,7 +4724,7 @@
   if (tabDose.TabIndex = TI_COMPLEX) and chkDoseNow.Checked  then
   begin
-    if ( (ValueOf(FLD_SCHED_TYP) <> 'O') and (InfoBox('Give Additional Dose Now is in addition to those listed in the table.' + CRLF +
+    if (InfoBox('Give Additional Dose Now is in addition to those listed in the table.' + CRLF +
                  'Please adjust the duration of the first row, if necessary.',
-                 'Give Additional Dose Now for Complex Order', MB_OKCANCEL or MB_ICONWARNING) = IDCANCEL) ) then
+                 'Give Additional Dose Now for Complex Order', MB_OKCANCEL or MB_ICONWARNING) = IDCANCEL) then
     begin
       chkDoseNow.Checked := False;
